﻿$(function () {
    var examplesData = {
        items: [
            {
                id: "examples",
                title: "Examples",
                items: [
                    {
                        id: "window",
                        title: "Window",
                        items: [
                            {
                                id: "simplewindow",
                                title: "Simple Window",
                                items: []
                            },
                            {
                                id: "dialogwindow",
                                title: "Dialog Window",
                                items: []
                            },
                            {
                                id: "modaldialogwindow",
                                title: "Modal Dialog Window",
                                items: []
                            },
                            {
                                id: "customdialogwindow",
                                title: "Custom Dialog Window",
                                items: []
                            }
                        ]
                    },
                    {
                        id: "textbox",
                        title: "TextBox Control",
                        items: []
                    },
                    {
                        id: "textarea",
                        title: "TextArea Control",
                        items: []
                    },
                    {
                        id: "statictext",
                        title: "StaticText Control",
                        items: []
                    },
                    {
                        id: "checkbox",
                        title: "CheckBox Control",
                        items: []
                    },
                    {
                        id: "combobox",
                        title: "ComboBox Control",
                        items: []
                    },
                    {
                        id: "image",
                        title: "Image Control",
                        items: []
                    },
                    {
                        id: "groupbox",
                        title: "GroupBox Control",
                        items: []
                    },
                    {
                        id: "button",
                        title: "Button Control",
                        items: []
                    },
                    {
                        id: "objectselector",
                        title: "ObjectSelector Control",
                        items: [
                            {
                                id: "objectselectorgrid",
                                title: "ObjectSelector Control With GridView",
                                items: []
                            },
                            {
                                id: "objectselectortree",
                                title: "ObjectSelector Control With TreeView",
                                items: []
                            }
                        ]
                    }
                ]
            }
        ]
    };

    var examplesTreeWindow = redui.createNewWindow("ExamplesTree");
    examplesTreeWindow.bind(examplesData);
    examplesTreeWindow.dock($("#project_tree_inner"));

    var emptyWindow = redui.createNewWindow("EmptyWindow");
    emptyWindow.dock($("#details_view_inner"));

    $("#" + examplesTreeWindow.examplesTree.roots[0].id + "_expander").trigger("click");

    function loadPage(url) {
        var page = "";
        $.ajax({
            url: url,
            dataType: "html",
            async: false,
            success: function (data) {
                page = data;
            }
        });
        return page;
    }


    examplesTreeWindow.examplesTree.nodeSelected(function (target, node) {
        if (node.bindingContext.id === "examples") {
            var page = loadPage("/demo/resources/Examples.html");

            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").empty();
            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").append(page);
        }
        else if (node.bindingContext.id === "textbox") {
            var page = loadPage("/demo/resources/TextBox_Example.html");

            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").empty();
            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").append(page);

            $("#TextBoxControlExample").click(function () {
                showTextBoxExample();
            });
        }
        else if (node.bindingContext.id === "textarea") {
            var page = loadPage("/demo/resources/TextArea_Example.html");

            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").empty();
            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").append(page);

            $("#TextAreaControlExample").click(function () {
                showTextAreaExample();
            });
        }
        else if (node.bindingContext.id === "checkbox") {
            var page = loadPage("/demo/resources/CheckBox_Example.html");

            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").empty();
            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").append(page);

            $("#CheckBoxControlExample").click(function () {
                showCheckBoxExample();
            });
        }
        else if (node.bindingContext.id === "statictext") {
            var page = loadPage("/demo/resources/StaticText_Example.html");

            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").empty();
            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").append(page);

            $("#StaticTextControlExample").click(function () {
                showStaticTextExample();
            });
        }
        else if (node.bindingContext.id === "combobox") {
            var page = loadPage("/demo/resources/ComboBox_Example.html");

            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").empty();
            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").append(page);

            $("#ComboBoxControlExample").click(function () {
                showComboBoxExample();
            });
        }
        else if (node.bindingContext.id === "image") {
            var page = loadPage("/demo/resources/Image_Example.html");

            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").empty();
            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").append(page);

            $("#ImageControlExample").click(function () {
                showImageExample();
            });
        }
        else if (node.bindingContext.id === "groupbox") {
            var page = loadPage("/demo/resources/GroupBox_Example.html");

            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").empty();
            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").append(page);

            $("#GroupBoxControlExample").click(function () {
                showGroupBoxExample();
            });
        }
        else if (node.bindingContext.id === "button") {
                var page = loadPage("/demo/resources/Button_Example.html");

                $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").empty();
                $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").append(page);

                $("#ButtonControlExample").click(function () {
                    showButtonExample();
                });
            }
        if (node.bindingContext.id === "objectselector") {
            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").empty();
        }
        else if (node.bindingContext.id === "objectselectorgrid") {
                var page = loadPage("/demo/resources/ObjectSelector_Example1.html");

                $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").empty();
                $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").append(page);

                $("#ObjectSelectorControlWithGridExample").click(function () {
                    showObjectSelectorWithGridExample();
                });
            }
        else if (node.bindingContext.id === "objectselectortree") {
                var page = loadPage("/demo/resources/ObjectSelector_Example2.html");

                $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").empty();
                $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").append(page);

                $("#ObjectSelectorControlWithTreeExample").click(function () {
                    showObjectSelectorWithTreeExample();
                });
            }
        if (node.bindingContext.id === "window") {
            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").empty();
        }
        else if (node.bindingContext.id === "simplewindow") {
            var page = loadPage("/demo/resources/Window_Example1.html");

            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").empty();
            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").append(page);

            $("#SimpleWindowExample").click(function () {
                showSimpleWindowExample();
            });
        }
        else if (node.bindingContext.id === "dialogwindow") {
            var page = loadPage("/demo/resources/Window_Example2.html");

            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").empty();
            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").append(page);

            $("#DialogWindowExample").click(function () {
                showDialogWindowExample();
            });
        }
        else if (node.bindingContext.id === "modaldialogwindow") {
            var page = loadPage("/demo/resources/Window_Example3.html");

            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").empty();
            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").append(page);

            $("#ModalDialogWindowExample").click(function () {
                showModalDialogWindowExample();
            });
        }
        else if (node.bindingContext.id === "customdialogwindow") {
            var page = loadPage("/demo/resources/Window_Example4.html");

            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").empty();
            $("#" + emptyWindow.id + "_clientareainner .redui-window-clientarea-layoutpanel").append(page);

            $("#CustomDialogWindowExample").click(function () {
                showCustomDialogWindowExample();
            });
        }
    });

    function showTextBoxExample() {
        var playerData = {
            firstName: "Claudio",
            lastName: "Marchisio",
        };

        var exampleWindow = redui.createNewWindow("TextBoxExample");
        exampleWindow.bind(playerData);
        exampleWindow.show();
    }

    function showTextAreaExample() {
        var data = {
            description: "Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum."
        };

        var exampleWindow = redui.createNewWindow("TextAreaExample");
        exampleWindow.bind(data);
        exampleWindow.show();
    }

    function showCheckBoxExample() {
        var animalData = {
            canWalk: true,
            canFly: false,
            canSwim: true
        };

        var exampleWindow = redui.createNewWindow("CheckBoxExample");
        exampleWindow.bind(animalData);
        exampleWindow.show();
    }

    function showStaticTextExample() {
        var info = {
            text: "Are you sure?"
        };

        var exampleWindow = redui.createNewWindow("StaticTextExample");
        exampleWindow.bind(info);
        exampleWindow.show();
    }

    function showComboBoxExample() {
        var addressData = {
            country: "fr"
        };

        var countries = [
            { id: "", value: "" },
            { id: "be", value: "Belgium" },
            { id: "fr", value: "France" },
            { id: "it", value: "Italy" },
            { id: "nl", value: "Netherlands" }
        ];

        redui.optionsBag.getcountries = function () {
            return countries;
        };

        var exampleWindow = redui.createNewWindow("ComboBoxExample");
        exampleWindow.bind(addressData);
        exampleWindow.show();
    }

    function showImageExample() {
        var userData = {
            imageUri: "/demo/resources/user-admin.png"
        };

        var exampleWindow = redui.createNewWindow("ImageExample");
        exampleWindow.bind(userData);
        exampleWindow.show();
    }

    function showGroupBoxExample() {
        var customerData = {
            firstName: "Mario",
            lastName: "Pizzi",
            address: {
                street: "Via Roma",
                zip: 1000,
                city: "Torino"
            }
        };

        var exampleWindow = redui.createNewWindow("GroupBoxExample");
        exampleWindow.bind(customerData);
        exampleWindow.show();
    }

    function showButtonExample() {
        var exampleWindow = redui.createNewWindow("ButtonExample");
        exampleWindow.show();

        exampleWindow.SimpleButton.getElement().click(function () {
            alert("Simple button clicked");
        });
        exampleWindow.DialogButton.getElement().click(function () {
            alert("Dialog button clicked");
        });
    }

    function showObjectSelectorWithGridExample() {
        var playerData = {
            firstName: "Claudio",
            lastName: "Marchisio",
            manager: {}
        };

        // Options for object selector
        var teamManagement = {
            list: [
                {
                    id: 7,
                    title: "Manager",
                    name: "Antonio Conte",
                },
                {
                    id: 8,
                    title: "Goalkeeping Coach",
                    name: "Claudio Filippi",
                },
                {
                    id: 9,
                    title: "Assistant Manager",
                    name: "Angelo Alessio",
                },
                {
                    id: 10,
                    title: "First-team Coach",
                    name: "Massimo Carrera",
                }
            ]
        };

        // This function will be called when user clicks lookup button of the object selector
        redui.objectSources.getManager = function (callback) {
            // This window is used to select a manager
            var managersWindow = redui.createNewWindow("ObjectSelectorGridSelector");
            managersWindow.bind(teamManagement);

            managersWindow.closed(function (target, dialogResult) {
                if (dialogResult === "OK") {
                    // If the row was selected,
                    // Get the object bound to the current row
                    var currentRow = managersWindow.managersGrid.currentRow;
                    if (currentRow) {
                        var object = currentRow.bindingContext;
                    }
                    // Return object to the object selector
                    callback(object);
                }
            });

            managersWindow.showModal();
        };

        var exampleWindow = redui.createNewWindow("ObjectSelectorExample");
        exampleWindow.bind(playerData);
        exampleWindow.show();
    }

    function showObjectSelectorWithTreeExample() {
        var playerData = {
            firstName: "Claudio",
            lastName: "Marchisio",
            manager: {}
        };

        // Options for object selector
        var corporateManagement = {
            items: [
                {
                    id: 1,
                    title: "Chairman",
                    name: "Andrea Agnelli",
                    items: []
                },
                {
                    id: 2,
                    title: "CFO",
                    name: "Aldo Mazzia",
                    items: []
                },
                {
                    id: 3,
                    title: "General Manager",
                    name: "Giuseppe Marotta",
                    items: [
                        {
                            id: 5,
                            title: "Sports Director",
                            name: "Fabio Paratici",
                            items: []
                        },
                        {
                            id: 6,
                            title: "Team Manager",
                            name: "Matteo Fabris",
                            items: [
                                {
                                    id: 7,
                                    title: "Manager",
                                    name: "Antonio Conte",
                                    items: []
                                },
                                {
                                    id: 8,
                                    title: "Goalkeeping Coach",
                                    name: "Claudio Filippi",
                                    items: []
                                },
                                {
                                    id: 9,
                                    title: "Assistant Manager",
                                    name: "Angelo Alessio",
                                    items: []
                                },
                                {
                                    id: 10,
                                    title: "First-team Coach",
                                    name: "Massimo Carrera",
                                    items: []
                                }
                            ]
                        }
                    ]
                },
                {
                    id: 4,
                    title: "Director",
                    name: "Pavel Nedved",
                    items: []
                }
            ]
        };

        // This function will be called when user clicks lookup button of the object selector
        redui.objectSources.getManager = function (callback) {
            // This window is used to select a manager
            var managersWindow = redui.createNewWindow("ObjectSelectorTreeSelector");
            managersWindow.bind(corporateManagement);

            managersWindow.closed(function (target, dialogResult) {
                if (dialogResult === "OK") {
                    // If the node was selected,
                    // Get the object bound to the current node
                    var currentNode = managersWindow.managersTree.currentNode;
                    if (currentNode) {
                        var object = currentNode.bindingContext;
                    }
                    // Return object to the object selector
                    callback(object);
                }
            });

            managersWindow.showModal();
        };

        var exampleWindow = redui.createNewWindow("ObjectSelectorExample");
        exampleWindow.bind(playerData);
        exampleWindow.show();
    }

    function showSimpleWindowExample() {
        var exampleWindow = redui.createNewWindow("SimpleWindowExample");
        exampleWindow.show();
    }

    function showDialogWindowExample() {
        var exampleWindow = redui.createNewWindow("DialogWindowExample");
        exampleWindow.show();

        exampleWindow.closed(function (target, dialogResult) {
            if (dialogResult === "OK") {
                alert("You clicked OK");
            }
            if (dialogResult === "Cancel") {
                alert("You clicked Cancel");
            }
        });
    }

    function showModalDialogWindowExample() {
        var exampleWindow = redui.createNewWindow("DialogWindowExample");
        exampleWindow.showModal();

        exampleWindow.closed(function (target, dialogResult) {
            if (dialogResult === "OK") {
                alert("You clicked OK");
            }
            if (dialogResult === "Cancel") {
                alert("You clicked Cancel");
            }
        });
    }

    function showCustomDialogWindowExample() {
        var exampleWindow = redui.createNewWindow("CustomDialogWindowExample");
        exampleWindow.showModal();

        exampleWindow.closed(function (target, dialogResult) {
            if (dialogResult === "Yes") {
                alert("You clicked Yes");
            }
            if (dialogResult === "No") {
                alert("You clicked No");
            }
            if (dialogResult === "Cancel") {
                alert("Closing window this way returns Cancel");
            }
        });
    }

});