﻿{
    "windows": [
        {
            "name": "DepartmentTree",
            "title": "Department",
            "left": 50,
            "top": 50,
            "width": 200,
            "height": 200,
            "controls": [
                {
                    "name": "dockButton",
                    "type": "button",
                    "text": "Dock"
                },
                {
                    "name": "undockButton",
                    "type": "button",
                    "text": "Undock"
                },
                {
                    "name": "departmentTree",
                    "type": "treeview",
                    "bindsTo": "list",
                    "nodeModel": {
                        "name": "departmentTreeNode",
                        "type": "treeviewnode",
                        "bindsTo": "list",
                        "controls": [
                            {
                                "name": "isSelectedCheckBox",
                                "type": "checkbox",
                                "bindsTo": "isSelected"
                            },
                            {
                                "name": "nodeIcon",
                                "type": "image",
                                "alternateText": "Icon",
                                "width": 16,
                                "height": 16,
                                "bindsTo": "image"
                            },
                            {
                                "name": "titleStaticText",
                                "type": "statictext",
                                "text": "",
                                "bindsTo": "title"
                            },
                            {
                                "name": "nameStaticText",
                                "type": "statictext",
                                "text": "",
                                "bindsTo": "name"
                            }
                        ]
                    }
                }
            ]
        },
        {
            "name": "DepartmentTreeSelector",
            "title": "Department",
            "left": 50,
            "top": 50,
            "width": 600,
            "height": 600,
            "controls": [
                {
                    "name": "departmentTree",
                    "type": "treeview",
                    "label": "Department",
                    "bindsTo": "list",
                    "nodeModel": {
                        "name": "departmentTreeNode",
                        "type": "treeviewnode",
                        "bindsTo": "list",
                        "controls": [
                            {
                                "name": "isSelectedCheckBox",
                                "type": "checkbox",
                                "bindsTo": "isSelected"
                            },
                            {
                                "name": "nodeIcon",
                                "type": "image",
                                "alternateText": "Icon",
                                "width": 16,
                                "height": 16,
                                "bindsTo": "image"
                            },
                            {
                                "name": "titleStaticText",
                                "type": "statictext",
                                "text": "",
                                "bindsTo": "title"
                            },
                            {
                                "name": "nameStaticText",
                                "type": "statictext",
                                "text": "",
                                "bindsTo": "name"
                            }
                        ]
                    }
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "CustomersGrid",
            "title": "All Customers",
            "left": 451,
            "top": 50,
            "width": 800,
            "height": 600,
            "controls": [
                {
                    "name": "customersGrid",
                    "label": "Editable Grid",
                    "type": "gridview",
                    "bindsTo": "list",
                    "createNewRowValueFunction": "createNewRowValue",
                    "columns": [
                        {
                            "type": "gridviewcheckboxcolumn",
                            "name": "isSelected",
                            "label": "Select",
                            "width": 60,
                            "bindsTo": "isSelected"
                        },
                        {
                            "type": "gridviewtextboxcolumn",
                            "name": "firstName",
                            "label": "First Name",
                            "width": 120,
                            "bindsTo": "firstName"
                        },
                        {
                            "type": "gridviewtextboxcolumn",
                            "name": "lastName",
                            "label": "Last Name",
                            "width": 120,
                            "bindsTo": "lastName"
                        },
                        {
                            "type": "gridviewcomboboxcolumn",
                            "name": "country",
                            "label": "Country",
                            "width": 100,
                            "bindsTo": "address.country",
                            "getOptionsFunction": "getcountries",
                            "optionIdProperty": "optid",
                            "optionValueProperty": "optvalue"
                        },
                        {
                            "type": "gridviewobjectselectorcolumn",
                            "name": "manager",
                            "label": "Manager",
                            "width": 120,
                            "bindsTo": "manager",
                            "getObjectFunction": "getManager",
                            "objectValueProperty": "name"
                        },
                        {
                            "type": "gridviewtextboxcolumn",
                            "name": "age",
                            "label": "Age",
                            "width": 60,
                            "bindsTo": "age"
                        }
                    ]
                },
                {
                    "name": "SaveButton",
                    "type": "button",
                    "text": "Save"
                },
                {
                    "name": "EditButton",
                    "type": "button",
                    "text": "Edit"
                },
                {
                    "name": "BigDataButton",
                    "type": "button",
                    "text": "BigData"
                },
                {
                    "name": "BigPagedDataButton",
                    "type": "button",
                    "text": "BigData Paged"
                },
                {
                    "name": "PagersButton",
                    "type": "button",
                    "text": "Pagers"
                },
                {
                    "name": "customersReadOnlyGrid",
                    "label": "Read-Only Grid",
                    "type": "gridview",
                    "bindsTo": "list",
                    "canUserAddRows": false,
                    "columns": [
                        {
                            "type": "gridviewcheckboxcolumn",
                            "name": "isSelected",
                            "label": "Select",
                            "width": 60,
                            "bindsTo": "isSelected"
                        },
                        {
                            "type": "gridviewstatictextcolumn",
                            "name": "firstName",
                            "label": "First Name",
                            "width": 150,
                            "bindsTo": "firstName"
                        },
                        {
                            "type": "gridviewstatictextcolumn",
                            "name": "lastName",
                            "label": "Last Name",
                            "width": 250,
                            "bindsTo": "lastName"
                        },
                        {
                            "type": "gridviewstatictextcolumn",
                            "name": "age",
                            "label": "Age",
                            "width": 100,
                            "bindsTo": "age",
                            "cssClass": "redui-demo-bold"
                        }
                    ]
                }
            ]
        },
        {
            "name": "CustomerDetailsSingleContext",
            "title": "Customer Details",
            "left": 451,
            "top": 350,
            "width": 600,
            "height": 500,
            "controls": [
                {
                    "name": "generalStaticText",
                    "type": "statictext",
                    "text": "General Info"
                },
                {
                    "name": "customerFirstNameTextBox",
                    "type": "textbox",
                    "label": "First Name",
                    "bindsTo": "firstName"
                },
                {
                    "name": "customerLastNameTextBox",
                    "type": "textbox",
                    "label": "Last Name",
                    "bindsTo": "lastName"
                },
                {
                    "name": "addressGroupBox",
                    "type": "groupbox",
                    "label": "Address",
                    "controls": [
                        {
                            "name": "streetTextBox",
                            "type": "textbox",
                            "label": "Street",
                            "bindsTo": "address.street"
                        },
                        {
                            "name": "zipTextBox",
                            "type": "textbox",
                            "label": "Zip",
                            "bindsTo": "address.zip"
                        },
                        {
                            "name": "cityTextBox",
                            "type": "textbox",
                            "label": "City",
                            "bindsTo": "address.city"
                        },
                        {
                            "name": "countryComboBox",
                            "type": "combobox",
                            "label": "Country",
                            "bindsTo": "address.country",
                            "getOptionsFunction": "getcountries"
                        }
                    ]
                },
                {
                    "name": "vipCheckBox",
                    "type": "checkbox",
                    "label": "VIP",
                    "bindsTo": "isVip"
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel"
                }
            ]
        },
        {
            "name": "CustomerDetailsGroupBoxChangesContext",
            "title": "Customer Details",
            "left": 1280,
            "top": 50,
            "width": 600,
            "height": 500,
            "controls": [
                {
                    "name": "generalGroupBox",
                    "type": "groupbox",
                    "label": "General Info",
                    "controls": [
						{
						    "name": "customerFirstNameTextBox",
						    "type": "textbox",
						    "label": "First Name",
						    "bindsTo": "firstName"
						},
						{
						    "name": "customerLastNameTextBox",
						    "type": "textbox",
						    "label": "Last Name",
						    "bindsTo": "lastName"
						},
						{
						    "name": "detailslStaticText",
						    "type": "statictext",
						    "text": "Details"
						},
						{
						    "name": "customerAgeTextBox",
						    "type": "textbox",
						    "label": "Age",
						    "bindsTo": "age"
						},
						{
						    "name": "managerObjectSelector",
						    "type": "objectselector",
						    "label": "Manager",
						    "bindsTo": "manager",
						    "getObjectFunction": "getManager",
						    "objectValueProperty": "name"
						},
						{
						    "name": "vipCheckBox",
						    "type": "checkbox",
						    "label": "VIP",
						    "bindsTo": "isVip"
						},
						{
						    "name": "descriptionTextArea",
						    "type": "textarea",
						    "label": "Description",
						    "bindsTo": "description",
						    "columns": 30,
						    "rows": 10
						}
                    ]
                },
                {
                    "name": "addressGroupBox",
                    "type": "groupbox",
                    "label": "Address",
                    "bindingContext": "address",
                    "controls": [
                        {
                            "name": "streetTextBox",
                            "type": "textbox",
                            "label": "Street",
                            "bindsTo": "street"
                        },
                        {
                            "name": "zipTextBox",
                            "type": "textbox",
                            "label": "Zip",
                            "bindsTo": "zip"
                        },
                        {
                            "name": "cityTextBox",
                            "type": "textbox",
                            "label": "City",
                            "bindsTo": "city"
                        },
                        {
                            "name": "countryComboBox",
                            "type": "combobox",
                            "label": "Country",
                            "bindsTo": "country",
                            "getOptionsFunction": "getcountries",
                            "optionIdProperty": "optid",
                            "optionValueProperty": "optvalue"
                        }
                    ]
                },
				{
				    "name": "EditButton",
				    "type": "button",
				    "text": "Edit",
				    "isDialogButton": true
				},
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "CustomerDetailsWindowChangesContext",
            "title": "Customer Details",
            "left": 451,
            "top": 350,
            "width": 600,
            "height": 500,
            "bindingContext": "some.property",
            "controls": [
                {
                    "name": "generalStaticText",
                    "type": "statictext",
                    "text": "General Info"
                },
                {
                    "name": "customerFirstNameTextBox",
                    "type": "textbox",
                    "label": "First Name",
                    "bindsTo": "firstName"
                },
                {
                    "name": "customerLastNameTextBox",
                    "type": "textbox",
                    "label": "Last Name",
                    "bindsTo": "lastName"
                },
                {
                    "name": "addressGroupBox",
                    "type": "groupbox",
                    "label": "Address",
                    "bindingContext": "address",
                    "controls": [
                        {
                            "name": "streetTextBox",
                            "type": "textbox",
                            "label": "Street",
                            "bindsTo": "street"
                        },
                        {
                            "name": "zipTextBox",
                            "type": "textbox",
                            "label": "Zip",
                            "bindsTo": "zip"
                        },
                        {
                            "name": "cityTextBox",
                            "type": "textbox",
                            "label": "City",
                            "bindsTo": "city"
                        },
                        {
                            "name": "countryComboBox",
                            "type": "combobox",
                            "label": "Country",
                            "bindsTo": "country",
                            "getOptionsFunction": "getcountries"
                        }
                    ]
                },
                {
                    "name": "vipCheckBox",
                    "type": "checkbox",
                    "label": "VIP",
                    "bindsTo": "isVip"
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel"
                }
            ]
        },
        {
            "name": "SimpleBindingExample",
            "title": "Customer Details",
            "width": 400,
            "height": 300,
            "controls": [
                {
                    "name": "firstNameTextBox",
                    "type": "textbox",
                    "label": "First Name",
                    "bindsTo": "firstName"
                },
                {
                    "name": "lastNameTextBox",
                    "type": "textbox",
                    "label": "Last Name",
                    "bindsTo": "lastName"
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "TextAreaBindingExample",
            "title": "Customer Details",
            "width": 500,
            "height": 400,
            "controls": [
                {
                    "name": "firstNameTextBox",
                    "type": "textbox",
                    "label": "First Name",
                    "bindsTo": "firstName"
                },
                {
                    "name": "lastNameTextBox",
                    "type": "textbox",
                    "label": "Last Name",
                    "bindsTo": "lastName"
                },
                {
                    "name": "descriptionTextBox",
                    "type": "textarea",
                    "label": "Description",
                    "bindsTo": "description",
                    "columns": 40,
                    "rows": 10
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "CheckBoxBindingExample",
            "title": "Customer Details",
            "width": 400,
            "height": 300,
            "controls": [
                {
                    "name": "firstNameTextBox",
                    "type": "textbox",
                    "label": "First Name",
                    "bindsTo": "firstName"
                },
                {
                    "name": "lastNameTextBox",
                    "type": "textbox",
                    "label": "Last Name",
                    "bindsTo": "lastName"
                },
                {
                    "name": "vipCheckBox",
                    "type": "checkbox",
                    "label": "VIP",
                    "bindsTo": "isVip"
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "AddressEditor",
            "title": "Address",
            "width": 400,
            "height": 400,
            "controls": [
                {
                    "name": "streetTextBox",
                    "type": "textbox",
                    "label": "Street",
                    "bindsTo": "street"
                },
                {
                    "name": "zipTextBox",
                    "type": "textbox",
                    "label": "Zip",
                    "bindsTo": "zip"
                },
                {
                    "name": "cityTextBox",
                    "type": "textbox",
                    "label": "City",
                    "bindsTo": "city"
                },
                {
                    "name": "countryComboBox",
                    "type": "combobox",
                    "label": "Country",
                    "bindsTo": "country",
                    "getOptionsFunction": "getcountries",
                    "optionIdProperty": "optid",
                    "optionValueProperty": "optvalue"
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "CustomersSimpleGrid",
            "title": "All Customers",
            "width": 800,
            "height": 600,
            "controls": [
                {
                    "name": "customersGrid",
                    "label": "Customers",
                    "type": "gridview",
                    "bindsTo": "list",
                    "canUserAddRows": true,
                    "createNewRowValueFunction": "createNewRowValue",
                    "columns": [
                        {
                            "type": "gridviewcheckboxcolumn",
                            "name": "isSelected",
                            "label": "Select",
                            "width": 60,
                            "bindsTo": "isSelected"
                        },
                        {
                            "type": "gridviewtextboxcolumn",
                            "name": "firstName",
                            "label": "First Name",
                            "width": 120,
                            "bindsTo": "firstName"
                        },
                        {
                            "type": "gridviewtextboxcolumn",
                            "name": "lastName",
                            "label": "Last Name",
                            "width": 120,
                            "bindsTo": "lastName"
                        },
                        {
                            "type": "gridviewcomboboxcolumn",
                            "name": "country",
                            "label": "Country",
                            "width": 100,
                            "bindsTo": "address.country",
                            "getOptionsFunction": "getcountries",
                            "optionIdProperty": "optid",
                            "optionValueProperty": "optvalue"
                        },
                        {
                            "type": "gridviewtextboxcolumn",
                            "name": "age",
                            "label": "Age",
                            "width": 60,
                            "bindsTo": "age"
                        }
                    ]
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "DepartmentTreeEditable",
            "title": "Department",
            "width": 1200,
            "height": 600,
            "controls": [
                {
                    "name": "departmentTree",
                    "type": "treeview",
                    "bindsTo": "list",
                    "nodeModel": {
                        "name": "departmentTreeNode",
                        "type": "treeviewnode",
                        "bindsTo": "list",
                        "controls": [
                            {
                                "name": "isSelectedCheckBox",
                                "type": "checkbox",
                                "bindsTo": "isSelected"
                            },
                            {
                                "name": "nodeIcon",
                                "type": "image",
                                "alternateText": "Icon",
                                "width": 16,
                                "height": 16,
                                "bindsTo": "image"
                            },
                            {
                                "name": "titleTextBox",
                                "type": "textbox",
                                "bindsTo": "title"
                            },
                            {
                                "name": "nameTextBox",
                                "type": "textbox",
                                "bindsTo": "name"
                            },
							{
							    "name": "assistantObjectSelector",
							    "type": "objectselector",
							    "bindsTo": "assistant",
							    "getObjectFunction": "getManager",
							    "objectValueProperty": "name"
							}
                        ]
                    }
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "CustomStylesAndHiddenExample",
            "title": "Customer Details",
            "width": 400,
            "height": 300,
            "controls": [
                {
                    "name": "firstNameTextBox",
                    "type": "textbox",
                    "label": "First Name",
                    "bindsTo": "firstName",
                    "cssClass": "redui-demo-bold"
                },
                {
                    "name": "lastNameTextBox",
                    "type": "textbox",
                    "label": "Last Name",
                    "bindsTo": "lastName",
                    "isHidden": true
                }
            ]
        },
        {
            "name": "PagersExample",
            "title": "Pagers",
            "width": 500,
            "height": 400,
            "controls": [
                {
                    "name": "unboundPager",
                    "type": "pager"
                },
                {
                    "name": "pager1",
                    "type": "pager",
                    "bindsTo": "pagerInfo1"
                },
                {
                    "name": "pager2",
                    "type": "pager",
                    "bindsTo": "pagerInfo2"
                },
                {
                    "name": "pager3",
                    "type": "pager",
                    "bindsTo": "pagerInfo3"
                },
                {
                    "name": "pager4",
                    "type": "pager",
                    "bindsTo": "pagerInfo4"
                }
            ]
        },
        {
            "name": "PaginationExample",
            "title": "Pagination",
            "width": 800,
            "height": 500,
            "controls": [
                {
                    "name": "customersGrid",
                    "label": "Customers",
                    "type": "gridview",
                    "bindsTo": "list",
                    "canUserAddRows": false,
                    "columns": [
                        {
                            "type": "gridviewcheckboxcolumn",
                            "name": "isSelected",
                            "label": "Select",
                            "width": 60,
                            "bindsTo": "isSelected"
                        },
                        {
                            "type": "gridviewtextboxcolumn",
                            "name": "firstName",
                            "label": "First Name",
                            "width": 120,
                            "bindsTo": "firstName"
                        },
                        {
                            "type": "gridviewtextboxcolumn",
                            "name": "lastName",
                            "label": "Last Name",
                            "width": 120,
                            "bindsTo": "lastName"
                        },
                        {
                            "type": "gridviewcomboboxcolumn",
                            "name": "country",
                            "label": "Country",
                            "width": 100,
                            "bindsTo": "address.country",
                            "getOptionsFunction": "getcountries",
                            "optionIdProperty": "optid",
                            "optionValueProperty": "optvalue"
                        },
                        {
                            "type": "gridviewtextboxcolumn",
                            "name": "age",
                            "label": "Age",
                            "width": 60,
                            "bindsTo": "age"
                        }
                    ]
                },
                {
                    "name": "pager",
                    "type": "pager",
                    "bindsTo": "pagerInfo"
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "ExamplesTree",
            "title": "Examples",
            "left": 50,
            "top": 50,
            "width": 200,
            "height": 200,
            "controls": [
                {
                    "name": "examplesTree",
                    "type": "treeview",
                    "bindsTo": "items",
                    "nodeModel": {
                        "name": "examplesTreeNode",
                        "type": "treeviewnode",
                        "bindsTo": "items",
                        "controls": [
                            {
                                "name": "titleStaticText",
                                "type": "statictext",
                                "text": "",
                                "bindsTo": "title"
                            }
                        ]
                    }
                }
            ]
        },
        {
            "name": "TextBoxExample",
            "title": "TextBox Example",
            "left": 500,
            "top": 100,
            "width": 400,
            "height": 300,
            "controls": [
                {
                    "name": "firstNameTextBox",
                    "type": "textbox",
                    "label": "First Name",
                    "bindsTo": "firstName"
                },
                {
                    "name": "lastNameTextBox",
                    "type": "textbox",
                    "label": "Last Name",
                    "bindsTo": "lastName"
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "TextAreaExample",
            "title": "TextArea Example",
            "left": 500,
            "top": 100,
            "width": 500,
            "height": 300,
            "controls": [
                {
                    "name": "descriptionTextArea",
                    "type": "textarea",
                    "label": "Description",
                    "bindsTo": "description"
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "CheckBoxExample",
            "title": "CheckBox Example",
            "left": 500,
            "top": 100,
            "width": 400,
            "height": 300,
            "controls": [
                {
                    "name": "canWalkCheckBox",
                    "type": "checkbox",
                    "label": "Can Walk",
                    "bindsTo": "canWalk"
                },
                {
                    "name": "canFlyCheckBox",
                    "type": "checkbox",
                    "label": "Can Fly",
                    "bindsTo": "canFly"
                },
                {
                    "name": "canSwimCheckBox",
                    "type": "checkbox",
                    "label": "Can Swim",
                    "bindsTo": "canSwim"
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "StaticTextExample",
            "title": "StaticText Example",
            "left": 500,
            "top": 100,
            "width": 400,
            "height": 300,
            "controls": [
                {
                    "name": "infoStaticText",
                    "type": "statictext",
                    "bindsTo": "text"
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "Yes",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "No",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "ComboBoxExample",
            "title": "ComboBox Example",
            "left": 500,
            "top": 100,
            "width": 400,
            "height": 300,
            "controls": [
                {
                    "name": "countryComboBox",
                    "type": "combobox",
                    "label": "Country",
                    "bindsTo": "country",
                    "getOptionsFunction": "getcountries"
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "ImageExample",
            "title": "Image Example",
            "left": 500,
            "top": 100,
            "width": 400,
            "height": 300,
            "controls": [
                {
                    "name": "userIcon",
                    "type": "image",
                    "alternateText": "User Icon",
                    "width": 64,
                    "height": 64,
                    "bindsTo": "imageUri"
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "GroupBoxExample",
            "title": "GroupBox Example",
            "left": 500,
            "top": 100,
            "width": 550,
            "height": 450,
            "controls": [
                {
                    "name": "customerFirstNameTextBox",
                    "type": "textbox",
                    "label": "First Name",
                    "bindsTo": "firstName"
                },
                {
                    "name": "customerLastNameTextBox",
                    "type": "textbox",
                    "label": "Last Name",
                    "bindsTo": "lastName"
                },
                {
                    "name": "addressGroupBox",
                    "type": "groupbox",
                    "label": "Address",
                    "controls": [
                        {
                            "name": "streetTextBox",
                            "type": "textbox",
                            "label": "Street",
                            "bindsTo": "address.street"
                        },
                        {
                            "name": "zipTextBox",
                            "type": "textbox",
                            "label": "Zip",
                            "bindsTo": "address.zip"
                        },
                        {
                            "name": "cityTextBox",
                            "type": "textbox",
                            "label": "City",
                            "bindsTo": "address.city"
                        }
                    ]
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "ButtonExample",
            "title": "Button Example",
            "left": 500,
            "top": 100,
            "width": 500,
            "height": 300,
            "controls": [
                {
                    "name": "SimpleButton",
                    "type": "button",
                    "text": "Simple Button"
                },
                {
                    "name": "DialogButton",
                    "type": "button",
                    "text": "Dialog Button",
                    "isDialogButton": true
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "ObjectSelectorExample",
            "title": "ObjectSelector Example",
            "left": 500,
            "top": 100,
            "width": 400,
            "height": 300,
            "controls": [
                {
                    "name": "firstNameTextBox",
                    "type": "textbox",
                    "label": "First Name",
                    "bindsTo": "firstName"
                },
                {
                    "name": "lastNameTextBox",
                    "type": "textbox",
                    "label": "Last Name",
                    "bindsTo": "lastName"
                },
                {
                    "name": "managerObjectSelector",
                    "type": "objectselector",
                    "label": "Manager",
                    "bindsTo": "manager",
                    "getObjectFunction": "getManager",
                    "objectValueProperty": "name"
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "ObjectSelectorGridSelector",
            "title": "Select Manager",
            "width": 500,
            "height": 300,
            "controls": [
                {
                    "name": "managersGrid",
                    "type": "gridview",
                    "bindsTo": "list",
                    "canUserAddRows": false,
                    "columns": [
                        {
                            "type": "gridviewstatictextcolumn",
                            "name": "title",
                            "label": "Title",
                            "width": 150,
                            "bindsTo": "title"
                        },
                        {
                            "type": "gridviewstatictextcolumn",
                            "name": "name",
                            "label": "Name",
                            "width": 250,
                            "bindsTo": "name"
                        }
                    ]
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "ObjectSelectorTreeSelector",
            "title": "Select Manager",
            "width": 500,
            "height": 300,
            "controls": [
                {
                    "name": "managersTree",
                    "type": "treeview",
                    "bindsTo": "items",
                    "nodeModel": {
                        "name": "managersTreeNode",
                        "type": "treeviewnode",
                        "bindsTo": "items",
                        "controls": [
                            {
                                "name": "nodeIcon",
                                "type": "image",
                                "alternateText": "Icon",
                                "width": 16,
                                "height": 16,
                                "source": "/demo/resources/user-admin.png"
                            },
                            {
                                "name": "titleStaticText",
                                "type": "statictext",
                                "bindsTo": "title"
                            },
                            {
                                "name": "nameStaticText",
                                "type": "statictext",
                                "bindsTo": "name"
                            }
                        ]
                    }
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "SimpleWindowExample",
            "title": "Simple Window Example",
            "left": 500,
            "top": 100,
            "width": 400,
            "height": 300
        },
        {
            "name": "DialogWindowExample",
            "title": "Dialog Window Example",
            "left": 500,
            "top": 100,
            "width": 400,
            "height": 300,
            "controls": [
                {
                    "name": "infoStaticText",
                    "type": "statictext",
                    "text": "Confirm the action by clicking OK or Cancel"
                },
                {
                    "name": "OKButton",
                    "type": "button",
                    "text": "OK",
                    "isDialogButton": true,
                    "dialogResult": "OK"
                },
                {
                    "name": "CancelButton",
                    "type": "button",
                    "text": "Cancel",
                    "isDialogButton": true,
                    "dialogResult": "Cancel"
                }
            ]
        },
        {
            "name": "CustomDialogWindowExample",
            "title": "Custom Dialog Window Example",
            "left": 500,
            "top": 100,
            "width": 400,
            "height": 300,
            "controls": [
                {
                    "name": "infoStaticText",
                    "type": "statictext",
                    "text": "Confirm the action by clicking Yes or No"
                },
                {
                    "name": "YesButton",
                    "type": "button",
                    "text": "Yes",
                    "isDialogButton": true,
                    "dialogResult": "Yes"
                },
                {
                    "name": "NoButton",
                    "type": "button",
                    "text": "No",
                    "isDialogButton": true,
                    "dialogResult": "No"
                }
            ]
        },
        {
            "name": "EmptyWindow"
        }
    ]
}